103. Traffic Lights

Time limit per test: 0.25 second(s)
Memory limit: 4096 kilobytes
input: standard
output: standard

In the city of Dingilville the traffic is arranged in an unusual way. There are junctions and roads connecting the junctions. There is at most one road between any two different junctions. There is no road connecting a junction to itself. Travel time for a road is the same for both directions. At every junction there is a single traffic light that is either blue or purple at any moment. The color of each light alternates periodically: blue for certain duration and then purple for another duration. Traffic is permitted to travel down the road between any two junctions, if and only if the lights at both junctions are the same color at the moment of departing from one junction for the other. If a vehicle arrives at a junction just at the moment the lights switch it must consider the new colors of lights. Vehicles are allowed to wait at the junctions. You are given the city map which shows:

  • the travel times for all roads (integers)
  • the durations of the two colors at each junction (integers)
  • and the initial color of the light and the remaining time (integer) for this color to change at each junction. 

    Your task is to find a path which takes the minimum time from a given source junction to a given destination junction for a vehicle when the traffic starts. In case more than one such path exists you are required to report only one of them.

    Input

    The first line contains two numbers: The id-number of the source junction and the id-number of the destination junction. The second line contains two numbers: NM. The following N lines contain information on N junctions. The (i+2)'th line of the input file holds information about the junction i : CiriCtiBtiP where Ci is either B for blue or P forpurple, indicating the initial color of the light at the junction i. Finally, the next M lines contain information on M roads. Each line is of the form: ijlij where i and j are the id-numbers of the junctions which are connected by this road. 2 ≤ N ≤ 300 where N is the number of junctions. The junctions are identified by integers 1 through N. These numbers are called id-numbers. 1 ≤ M ≤ 14000 where M is the number of roads. 1 ≤ lij ≤ 100 where lij is the time required to move from junction i to j using the road that connects i andj. 1 ≤ tiC ≤ 100 where tiC is the duration of the color c for the light at the junction i. The index c is either 'B' for blue or 'P' for purple. 1 ≤ riC ≤ tiC where riC is the remaining time for the initial color c at junction i.

    Output

    If a path exists:

  • The first line will contain the time taken by a minimum-time path from the source junction to the destination junction.
  • Second line will contain the list of junctions that construct the minimum-time path you have found. You have to write the junctions to the output file in the order of travelling. Therefore the first integer in this line must be the id-number of the source junction and the last one the id-number of the destination junction. 

    If a path does not exist:

  • A single line containing only the integer 0. 
    Example(s)
    sample input
    sample output
    1 4
    4 5
    B 2 16 99
    P 6 32 13
    P 2 87 4
    P 38 96 49
    1 2 4
    1 3 40
    2 3 75
    2 4 76
    3 4 77
    127
    1 2 4

题意:图,无自交,无向,在每个时间每个节点有一个信号灯,可能是绿色或者紫色,信号灯变化规律:蓝色持续一段时间接着是紫色,允许在信号灯同样颜色的时候离开一个节点通过路到达另一个节点,到达瞬间颜色可以不一样,如果到达瞬间颜色改变,按照新颜色计算,允许任意点停留,
你能得到的状态:
1 所有路径花费时间
2 每个节点灯的持续周期
3 每个节点灯的初始颜色和还剩多长时间第一次变颜色

思路:注意到这道题每个节点通向另一个节点耗时是容易得出的,而且过程有意义的只有最早到节点的时间,知道源点,到达点求最短路,最短路算法就可以了

注意状态转化,主要是考细心

实际用时:1h38min

#include <cstdio>
#include <cstring>
#include <queue>
using namespace std;
typedef long long ll;
const ll inf=0x7ffffffffff;
const int maxn=305;
const int maxm=50000;
int n,m;
ll dis[maxn];//最小距离(时间)
int first[maxn];//邻接表
int nxt[maxm];
int to[maxm];
int cost[maxm];
int color[maxn];//初始颜色
int wait[maxn];//第一次变化时间
int time[maxn][2];//等待颜色
int pre[maxn];//路径回溯,前驱节点
queue<int >que;
int sups,supe;
char buff[3];//接收颜色用
int heap[maxn],len;
void dfs(int s){//路径回溯
if(s==sups){
len=0;
heap[len++]=s;
return ;
}
dfs(pre[s]);
heap[len++]=s;
}
int calcolor(int ttime,int s){//计算当前颜色
if(ttime<wait[s])return color[s];
ttime-=wait[s];
int c=color[s]^1;
ttime-=((int)ttime/(time[s][0]+time[s][1]))*(time[s][0]+time[s][1]);
if(ttime<time[s][c])return c;
return color[s];
}
int caltime(int ttime,int s){//计算变化颜色时间
if(ttime<wait[s])return wait[s]-ttime;
ttime-=wait[s];
int c=color[s]^1;
ttime-=((int)ttime/(time[s][0]+time[s][1]))*(time[s][0]+time[s][1]);
if(ttime<time[s][c])return time[s][c]-ttime;
return time[s][0]+time[s][1]-ttime;
}
void addedge(int f,int t,int c,int ind){
nxt[ind*2]=first[f];
cost[ind*2]=c;
to[ind*2]=t;
first[f]=ind*2;
nxt[ind*2+1]=first[t];
cost[ind*2+1]=c;
to[ind*2+1]=f;
first[t]=ind*2+1;
}
void spfa(){
fill(dis,dis+n+1,inf);
que.push(sups);
dis[sups]=0;
while(!que.empty()){
int s=que.front();que.pop();
int scolor=calcolor(dis[s],s);
for(int p=first[s];p!=-1;p=nxt[p]){
int tto=to[p];
int tcolor=calcolor(dis[s],tto);
if(scolor==tcolor){
if(dis[tto]>dis[s]+cost[p]){//颜色相同可以直接走
dis[tto]=dis[s]+cost[p];
pre[tto]=s;
que.push(tto);
}
}
else {
int stime=caltime(dis[s],s);
int ttime=caltime(dis[s],tto);
if(stime==ttime&&time[s][scolor^1]==time[tto][tcolor^1]&&time[s][scolor]==time[tto][tcolor])continue;//这两个节点同步变化,永远走不了
if(stime==ttime){//如果变化周期不一样而现在等待时间一样就多等一周期
stime+=time[s][scolor^1];
ttime+=time[tto][tcolor^1];
}
if(stime==ttime){//再多等一周期
stime+=time[s][scolor];
ttime+=time[tto][tcolor];
}
if(dis[tto]>dis[s]+min(stime,ttime)+cost[p]){//更新
dis[tto]=dis[s]+min(stime,ttime)+cost[p];
pre[tto]=s;
que.push(tto);
}
}
}
}
}
int main(){
while(scanf("%d%d",&sups,&supe)==2){
sups--;supe--;
memset(first,-1,sizeof(first));
scanf("%d%d",&n,&m);
for (int i=0;i<n;i++){
scanf("%s%d%d%d",buff,wait+i,time[i],time[i]+1);
if(buff[0]=='B')color[i]=0;
else color[i]=1;
}
for(int i=0;i<m;i++){
int f,t,c;
scanf("%d%d%d",&f,&t,&c);
f--;t--;
addedge(f,t,c,i);
}
spfa();
if(dis[supe]==inf)puts("0");
else {
printf("%I64d\n",dis[supe]);
dfs(supe);
for(int i=0;i<len;i++){
printf("%d%c",heap[i]+1,i==len-1?'\n':' ');
}
}
} return 0;
}

  

快速切题 sgu103. Traffic Lights 最短路 难度:1的更多相关文章

  1. 快速切题 poj 1003 hangover 数学观察 难度:0

    Hangover Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 103896   Accepted: 50542 Descr ...

  2. POJ1158 城市交通Traffic lights IOI 1999 (最短路)

    POJ1158 城市交通Traffic lights IOI 1999 (最短路) (1) 问题描述(probolem) 在d城里交通的安排不同寻常,城中有路口和路口之间的道路,再任意两个不同的路口之 ...

  3. sgu 103 Traffic Lights 解题报告及测试数据

    103. Traffic Lights Time limit per test: 0.25 second(s) Memory limit: 4096 kilobytes 题解: 1.其实就是求两点间的 ...

  4. Traffic Lights

    Traffic Lights time limit per test 2 seconds memory limit per test 256 megabytes input standard inpu ...

  5. SGU 103.Traffic Lights(最短路)

    时间: 0.50 second(s) 空间: 4096 kilobytes 输入: 标准输入 输出: 标准输出 Dingiville 城市的交通规则非常奇怪,城市公路通过路口相连,两个不同路口之间最多 ...

  6. 快速切题 poj 2485 Highways prim算法+堆 不完全优化 难度:0

    Highways Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 23033   Accepted: 10612 Descri ...

  7. Traffic Lights - SGU 103(最短路)

    题目大意:有一个城市的路线图,有N个交叉点,每两个交叉点之间只有一条路,现在想从交点u去交点v,不过这个路的交通比较特别,每个路都有一个交通灯,灯有两种颜色,蓝色和紫色,例如一条路线在交点s,t之间, ...

  8. 快速切题 sgu115. Calendar 模拟 难度:0

    115. Calendar time limit per test: 0.25 sec. memory limit per test: 4096 KB First year of new millen ...

  9. 快速切题 sgu113 Nearly prime numbers 难度:0

    113. Nearly prime numbers time limit per test: 0.25 sec. memory limit per test: 4096 KB Nearly prime ...

随机推荐

  1. VC 系统托盘编程,含有气泡提示

    转载一:http://blog.sina.com.cn/s/blog_6acf36ee0100rxdb.html 转载二:http://blog.csdn.net/akof1314/article/d ...

  2. Win32 文件拖拽

    1.响应系统消息  WM_DROPFILES 2.在响应函数里面获取拖拽文件路径 LRESULT OnDropFiles(UINT uMsg, WPARAM wParam, LPARAM lParam ...

  3. BZOJ 3339 && luogu4137 Rmq Problem / mex(莫队)

    P4137 Rmq Problem / mex 题目描述 有一个长度为n的数组{a1,a2,-,an}.m次询问,每次询问一个区间内最小没有出现过的自然数. 输入输出格式 输入格式: 第一行n,m. ...

  4. Centos7.2 安装Elasticsearch 6

    下载 elasticsearch.6.0.0.tar.gz 迁移文件到usr/local中 mv elasticsearch-.tar.gz /usr/local/ cd /usr/local tar ...

  5. IDEA,RubyMine等JetBrains系列软件通用破解教程

    此教程不光适用于IDEA,还可以在RubyMine等JetBrains系列软件使用,亲测可用. (1)下载安装你需要的JetBrains系列软件,安装完最好不要打开,直接finish,断开网络. (2 ...

  6. 51nod 1051 最大子矩阵和

    没想到居然可以O(n3)暴力过 就是大概之前的  最大连续子序列和 加成2维度了  枚举起始列 和 终止列 然后计算从1到n行最大的子矩阵的和 注意n 和 m 的输入顺序!! #include< ...

  7. BZOJ2982: combination Lucas

    Description LMZ有n个不同的基友,他每天晚上要选m个进行[河蟹],而且要求每天晚上的选择都不一样.那么LMZ能够持续多少个这样的夜晚呢?当然,LMZ的一年有10007天,所以他想知道答案 ...

  8. 论文笔记——Factorized Convolutional Neural Networks

    1. 论文思想 将3D卷积分解为spatial convolution in each channel and linear projection across channels. (spatial ...

  9. HDU 1248 寒冰王座(完全背包)

    http://acm.hdu.edu.cn/showproblem.php?pid=1248 题意: 商店里只有三种物品,价格分别为150,200,350.输入钱并计算浪费的钱的最小值,商店不找零. ...

  10. 51nod 1232 完美数 数位dp

    1232 完美数 题目来源: 胡仁东 基准时间限制:2 秒 空间限制:131072 KB  如果一个数能够被组成它的各个非0数字整除,则称它是完美数.例如:1-9都是完美数,10,11,12,101都 ...